#include "DatabaseHandler/DatabaseHandler.h"
#include "DatabaseHandler/Source/v2/DataClasses/Lineup.h"
#include "DatabaseHandlerTests/InMemoryDbFixture.h"

TEST_F(InMemoryDbFixture, LineupTests)
{
	using namespace database_handler;
	using namespace database_handler::v2;
	using namespace database_handler::common;
	
	Lineup lineup1;
	lineup1.sm_team_id = 1;
	lineup1.sm_fixture_id = 2;
	lineup1.sm_player_id = 3;
	lineup1.player_name = STR("player_name4");
	lineup1.number = 5;
	lineup1.position = STR("position6");
	lineup1.additional_position_opt = STR("additional_position_opt7");
	lineup1.formation_position_opt = 8;
	lineup1.posx_opt = 9;
	lineup1.posy_opt = 10;
	lineup1.captain_opt = true;
	lineup1.type = STR("type12");
	lineup1.shots_total_opt = 13;
	lineup1.shots_on_goal_opt = 14;
	lineup1.goals_scored_opt = 15;
	lineup1.goals_assists_opt = 16;
	lineup1.goals_conceded_opt = 17;
	lineup1.goals_owngoals_opt = 18;
	lineup1.fouls_drawn_opt = 19;
	lineup1.fouls_committed_opt = 20;
	lineup1.yellowcards_opt = 21;
	lineup1.redcards_opt = 22;
	lineup1.yellowredcards_opt = 23;
	lineup1.passing_total_crosses_opt = 24;
	lineup1.passing_crosses_accuracy_opt = 25;
	lineup1.passing_passes_opt = 26;
	lineup1.passing_accurate_passes_opt = 27;
	lineup1.passing_passes_accuracy_opt = 28;
	lineup1.passing_key_passes_opt = 29;
	lineup1.dribbles_attempts_opt = 30;
	lineup1.dribbles_success_opt = 31;
	lineup1.dribbles_dribbled_past_opt = 32;
	lineup1.duels_total_opt = 33;
	lineup1.duels_won_opt = 34;
	lineup1.aerials_won_opt = 35;
	lineup1.punches_opt = 36;
	lineup1.offsides_opt = 37;
	lineup1.saves_opt = 38;
	lineup1.inside_box_saves_opt = 39;
	lineup1.penalty_scored_opt = 40;
	lineup1.penalty_missed_opt = 41;
	lineup1.penalty_saved_opt = 42;
	lineup1.penalty_committed_opt = 43;
	lineup1.penalty_won_opt = 44;
	lineup1.hit_woodwork_opt = 45;
	lineup1.tackles_opt = 46;
	lineup1.blocks_opt = 47;
	lineup1.interceptions_opt = 48;
	lineup1.clearances_opt = 49;
	lineup1.dispossesed_opt = 50;
	lineup1.minutes_played_opt = 51;
	lineup1.rating_opt = 52.53;
	
	Lineup lineup2;
	
	Lineup lineup3;
	lineup3.sm_team_id = 54;
	lineup3.sm_fixture_id = 55;
	lineup3.sm_player_id = 56;
	lineup3.player_name = STR("player_name57");
	lineup3.number = 58;
	lineup3.position = STR("position59");
	lineup3.additional_position_opt = STR("additional_position_opt60");
	lineup3.formation_position_opt = 61;
	lineup3.posx_opt = 62;
	lineup3.posy_opt = 63;
	lineup3.captain_opt = false;
	lineup3.type = STR("type65");
	lineup3.shots_total_opt = 66;
	lineup3.shots_on_goal_opt = 67;
	lineup3.goals_scored_opt = 68;
	lineup3.goals_assists_opt = 69;
	lineup3.goals_conceded_opt = 70;
	lineup3.goals_owngoals_opt = 71;
	lineup3.fouls_drawn_opt = 72;
	lineup3.fouls_committed_opt = 73;
	lineup3.yellowcards_opt = 74;
	lineup3.redcards_opt = 75;
	lineup3.yellowredcards_opt = 76;
	lineup3.passing_total_crosses_opt = 77;
	lineup3.passing_crosses_accuracy_opt = 78;
	lineup3.passing_passes_opt = 79;
	lineup3.passing_accurate_passes_opt = 80;
	lineup3.passing_passes_accuracy_opt = 81;
	lineup3.passing_key_passes_opt = 82;
	lineup3.dribbles_attempts_opt = 83;
	lineup3.dribbles_success_opt = 84;
	lineup3.dribbles_dribbled_past_opt = 85;
	lineup3.duels_total_opt = 86;
	lineup3.duels_won_opt = 87;
	lineup3.aerials_won_opt = 88;
	lineup3.punches_opt = 89;
	lineup3.offsides_opt = 90;
	lineup3.saves_opt = 91;
	lineup3.inside_box_saves_opt = 92;
	lineup3.penalty_scored_opt = 93;
	lineup3.penalty_missed_opt = 94;
	lineup3.penalty_saved_opt = 95;
	lineup3.penalty_committed_opt = 96;
	lineup3.penalty_won_opt = 97;
	lineup3.hit_woodwork_opt = 98;
	lineup3.tackles_opt = 99;
	lineup3.blocks_opt = 100;
	lineup3.interceptions_opt = 101;
	lineup3.clearances_opt = 102;
	lineup3.dispossesed_opt = 103;
	lineup3.minutes_played_opt = 104;
	lineup3.rating_opt = 105.106;
	
	std::vector<UpLineup> oneLineup;
	oneLineup.emplace_back(std::make_unique<Lineup>(lineup1));

	std::vector<UpLineup> twolineups;
	twolineups.emplace_back(std::make_unique<Lineup>(lineup1));
	twolineups.emplace_back(std::make_unique<Lineup>(lineup2));

	std::vector<UpLineup> threelineups;
	threelineups.emplace_back(std::make_unique<Lineup>(lineup1));
	threelineups.emplace_back(std::make_unique<Lineup>(lineup2));
	threelineups.emplace_back(std::make_unique<Lineup>(lineup3));

	EXPECT_EQ(1, oneLineup.size());
	EXPECT_EQ(2, twolineups.size());
	EXPECT_EQ(3, threelineups.size());

	ASSERT_NO_THROW(db.exec(CREATE_TABLE_LINEUPS));
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, oneLineup));
	ASSERT_EQ(1, QueryCount<Lineup>(db));
	{
		auto lineups = QueryAll<Lineup>(db);
		EXPECT_EQ(1, lineups.size());

		EXPECT_NE(0, lineups[0]->id);
		EXPECT_EQ(lineup1.sm_team_id, lineups[0]->sm_team_id);
		EXPECT_EQ(lineup1.sm_fixture_id, lineups[0]->sm_fixture_id);
		EXPECT_EQ(lineup1.sm_player_id, lineups[0]->sm_player_id);
		EXPECT_EQ(lineup1.player_name, lineups[0]->player_name);
		EXPECT_EQ(lineup1.number, lineups[0]->number);
		EXPECT_EQ(lineup1.position, lineups[0]->position);
		EXPECT_EQ(lineup1.additional_position_opt, lineups[0]->additional_position_opt);
		EXPECT_EQ(lineup1.formation_position_opt, lineups[0]->formation_position_opt);
		EXPECT_EQ(lineup1.posx_opt, lineups[0]->posx_opt);
		EXPECT_EQ(lineup1.posy_opt, lineups[0]->posy_opt);
		EXPECT_EQ(lineup1.captain_opt, lineups[0]->captain_opt);
		EXPECT_EQ(lineup1.type, lineups[0]->type);
		EXPECT_EQ(lineup1.shots_total_opt, lineups[0]->shots_total_opt);
		EXPECT_EQ(lineup1.shots_on_goal_opt, lineups[0]->shots_on_goal_opt);
		EXPECT_EQ(lineup1.goals_scored_opt, lineups[0]->goals_scored_opt);
		EXPECT_EQ(lineup1.goals_assists_opt, lineups[0]->goals_assists_opt);
		EXPECT_EQ(lineup1.goals_conceded_opt, lineups[0]->goals_conceded_opt);
		EXPECT_EQ(lineup1.goals_owngoals_opt, lineups[0]->goals_owngoals_opt);
		EXPECT_EQ(lineup1.fouls_drawn_opt, lineups[0]->fouls_drawn_opt);
		EXPECT_EQ(lineup1.fouls_committed_opt, lineups[0]->fouls_committed_opt);
		EXPECT_EQ(lineup1.yellowcards_opt, lineups[0]->yellowcards_opt);
		EXPECT_EQ(lineup1.redcards_opt, lineups[0]->redcards_opt);
		EXPECT_EQ(lineup1.yellowredcards_opt, lineups[0]->yellowredcards_opt);
		EXPECT_EQ(lineup1.passing_total_crosses_opt, lineups[0]->passing_total_crosses_opt);
		EXPECT_EQ(lineup1.passing_crosses_accuracy_opt, lineups[0]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup1.passing_passes_opt, lineups[0]->passing_passes_opt);
		EXPECT_EQ(lineup1.passing_accurate_passes_opt, lineups[0]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup1.passing_passes_accuracy_opt, lineups[0]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup1.passing_key_passes_opt, lineups[0]->passing_key_passes_opt);
		EXPECT_EQ(lineup1.dribbles_attempts_opt, lineups[0]->dribbles_attempts_opt);
		EXPECT_EQ(lineup1.dribbles_success_opt, lineups[0]->dribbles_success_opt);
		EXPECT_EQ(lineup1.dribbles_dribbled_past_opt, lineups[0]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup1.duels_total_opt, lineups[0]->duels_total_opt);
		EXPECT_EQ(lineup1.duels_won_opt, lineups[0]->duels_won_opt);
		EXPECT_EQ(lineup1.aerials_won_opt, lineups[0]->aerials_won_opt);
		EXPECT_EQ(lineup1.punches_opt, lineups[0]->punches_opt);
		EXPECT_EQ(lineup1.offsides_opt, lineups[0]->offsides_opt);
		EXPECT_EQ(lineup1.saves_opt, lineups[0]->saves_opt);
		EXPECT_EQ(lineup1.inside_box_saves_opt, lineups[0]->inside_box_saves_opt);
		EXPECT_EQ(lineup1.penalty_scored_opt, lineups[0]->penalty_scored_opt);
		EXPECT_EQ(lineup1.penalty_missed_opt, lineups[0]->penalty_missed_opt);
		EXPECT_EQ(lineup1.penalty_saved_opt, lineups[0]->penalty_saved_opt);
		EXPECT_EQ(lineup1.penalty_committed_opt, lineups[0]->penalty_committed_opt);
		EXPECT_EQ(lineup1.penalty_won_opt, lineups[0]->penalty_won_opt);
		EXPECT_EQ(lineup1.hit_woodwork_opt, lineups[0]->hit_woodwork_opt);
		EXPECT_EQ(lineup1.tackles_opt, lineups[0]->tackles_opt);
		EXPECT_EQ(lineup1.blocks_opt, lineups[0]->blocks_opt);
		EXPECT_EQ(lineup1.interceptions_opt, lineups[0]->interceptions_opt);
		EXPECT_EQ(lineup1.clearances_opt, lineups[0]->clearances_opt);
		EXPECT_EQ(lineup1.dispossesed_opt, lineups[0]->dispossesed_opt);
		EXPECT_EQ(lineup1.minutes_played_opt, lineups[0]->minutes_played_opt);
		EXPECT_EQ(lineup1.rating_opt, lineups[0]->rating_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, twolineups));
	ASSERT_EQ(2, QueryCount<Lineup>(db));
	{
		auto lineups = QueryAll<Lineup>(db);
		EXPECT_EQ(2, lineups.size());

		EXPECT_NE(0, lineups[0]->id);
		EXPECT_EQ(lineup1.sm_team_id, lineups[0]->sm_team_id);
		EXPECT_EQ(lineup1.sm_fixture_id, lineups[0]->sm_fixture_id);
		EXPECT_EQ(lineup1.sm_player_id, lineups[0]->sm_player_id);
		EXPECT_EQ(lineup1.player_name, lineups[0]->player_name);
		EXPECT_EQ(lineup1.number, lineups[0]->number);
		EXPECT_EQ(lineup1.position, lineups[0]->position);
		EXPECT_EQ(lineup1.additional_position_opt, lineups[0]->additional_position_opt);
		EXPECT_EQ(lineup1.formation_position_opt, lineups[0]->formation_position_opt);
		EXPECT_EQ(lineup1.posx_opt, lineups[0]->posx_opt);
		EXPECT_EQ(lineup1.posy_opt, lineups[0]->posy_opt);
		EXPECT_EQ(lineup1.captain_opt, lineups[0]->captain_opt);
		EXPECT_EQ(lineup1.type, lineups[0]->type);
		EXPECT_EQ(lineup1.shots_total_opt, lineups[0]->shots_total_opt);
		EXPECT_EQ(lineup1.shots_on_goal_opt, lineups[0]->shots_on_goal_opt);
		EXPECT_EQ(lineup1.goals_scored_opt, lineups[0]->goals_scored_opt);
		EXPECT_EQ(lineup1.goals_assists_opt, lineups[0]->goals_assists_opt);
		EXPECT_EQ(lineup1.goals_conceded_opt, lineups[0]->goals_conceded_opt);
		EXPECT_EQ(lineup1.goals_owngoals_opt, lineups[0]->goals_owngoals_opt);
		EXPECT_EQ(lineup1.fouls_drawn_opt, lineups[0]->fouls_drawn_opt);
		EXPECT_EQ(lineup1.fouls_committed_opt, lineups[0]->fouls_committed_opt);
		EXPECT_EQ(lineup1.yellowcards_opt, lineups[0]->yellowcards_opt);
		EXPECT_EQ(lineup1.redcards_opt, lineups[0]->redcards_opt);
		EXPECT_EQ(lineup1.yellowredcards_opt, lineups[0]->yellowredcards_opt);
		EXPECT_EQ(lineup1.passing_total_crosses_opt, lineups[0]->passing_total_crosses_opt);
		EXPECT_EQ(lineup1.passing_crosses_accuracy_opt, lineups[0]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup1.passing_passes_opt, lineups[0]->passing_passes_opt);
		EXPECT_EQ(lineup1.passing_accurate_passes_opt, lineups[0]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup1.passing_passes_accuracy_opt, lineups[0]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup1.passing_key_passes_opt, lineups[0]->passing_key_passes_opt);
		EXPECT_EQ(lineup1.dribbles_attempts_opt, lineups[0]->dribbles_attempts_opt);
		EXPECT_EQ(lineup1.dribbles_success_opt, lineups[0]->dribbles_success_opt);
		EXPECT_EQ(lineup1.dribbles_dribbled_past_opt, lineups[0]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup1.duels_total_opt, lineups[0]->duels_total_opt);
		EXPECT_EQ(lineup1.duels_won_opt, lineups[0]->duels_won_opt);
		EXPECT_EQ(lineup1.aerials_won_opt, lineups[0]->aerials_won_opt);
		EXPECT_EQ(lineup1.punches_opt, lineups[0]->punches_opt);
		EXPECT_EQ(lineup1.offsides_opt, lineups[0]->offsides_opt);
		EXPECT_EQ(lineup1.saves_opt, lineups[0]->saves_opt);
		EXPECT_EQ(lineup1.inside_box_saves_opt, lineups[0]->inside_box_saves_opt);
		EXPECT_EQ(lineup1.penalty_scored_opt, lineups[0]->penalty_scored_opt);
		EXPECT_EQ(lineup1.penalty_missed_opt, lineups[0]->penalty_missed_opt);
		EXPECT_EQ(lineup1.penalty_saved_opt, lineups[0]->penalty_saved_opt);
		EXPECT_EQ(lineup1.penalty_committed_opt, lineups[0]->penalty_committed_opt);
		EXPECT_EQ(lineup1.penalty_won_opt, lineups[0]->penalty_won_opt);
		EXPECT_EQ(lineup1.hit_woodwork_opt, lineups[0]->hit_woodwork_opt);
		EXPECT_EQ(lineup1.tackles_opt, lineups[0]->tackles_opt);
		EXPECT_EQ(lineup1.blocks_opt, lineups[0]->blocks_opt);
		EXPECT_EQ(lineup1.interceptions_opt, lineups[0]->interceptions_opt);
		EXPECT_EQ(lineup1.clearances_opt, lineups[0]->clearances_opt);
		EXPECT_EQ(lineup1.dispossesed_opt, lineups[0]->dispossesed_opt);
		EXPECT_EQ(lineup1.minutes_played_opt, lineups[0]->minutes_played_opt);
		EXPECT_EQ(lineup1.rating_opt, lineups[0]->rating_opt);
		

		EXPECT_NE(0, lineups[1]->id);
		EXPECT_EQ(lineup2.sm_team_id, lineups[1]->sm_team_id);
		EXPECT_EQ(lineup2.sm_fixture_id, lineups[1]->sm_fixture_id);
		EXPECT_EQ(lineup2.sm_player_id, lineups[1]->sm_player_id);
		EXPECT_EQ(lineup2.player_name, lineups[1]->player_name);
		EXPECT_EQ(lineup2.number, lineups[1]->number);
		EXPECT_EQ(lineup2.position, lineups[1]->position);
		EXPECT_EQ(lineup2.additional_position_opt, lineups[1]->additional_position_opt);
		EXPECT_EQ(lineup2.formation_position_opt, lineups[1]->formation_position_opt);
		EXPECT_EQ(lineup2.posx_opt, lineups[1]->posx_opt);
		EXPECT_EQ(lineup2.posy_opt, lineups[1]->posy_opt);
		EXPECT_EQ(lineup2.captain_opt, lineups[1]->captain_opt);
		EXPECT_EQ(lineup2.type, lineups[1]->type);
		EXPECT_EQ(lineup2.shots_total_opt, lineups[1]->shots_total_opt);
		EXPECT_EQ(lineup2.shots_on_goal_opt, lineups[1]->shots_on_goal_opt);
		EXPECT_EQ(lineup2.goals_scored_opt, lineups[1]->goals_scored_opt);
		EXPECT_EQ(lineup2.goals_assists_opt, lineups[1]->goals_assists_opt);
		EXPECT_EQ(lineup2.goals_conceded_opt, lineups[1]->goals_conceded_opt);
		EXPECT_EQ(lineup2.goals_owngoals_opt, lineups[1]->goals_owngoals_opt);
		EXPECT_EQ(lineup2.fouls_drawn_opt, lineups[1]->fouls_drawn_opt);
		EXPECT_EQ(lineup2.fouls_committed_opt, lineups[1]->fouls_committed_opt);
		EXPECT_EQ(lineup2.yellowcards_opt, lineups[1]->yellowcards_opt);
		EXPECT_EQ(lineup2.redcards_opt, lineups[1]->redcards_opt);
		EXPECT_EQ(lineup2.yellowredcards_opt, lineups[1]->yellowredcards_opt);
		EXPECT_EQ(lineup2.passing_total_crosses_opt, lineups[1]->passing_total_crosses_opt);
		EXPECT_EQ(lineup2.passing_crosses_accuracy_opt, lineups[1]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup2.passing_passes_opt, lineups[1]->passing_passes_opt);
		EXPECT_EQ(lineup2.passing_accurate_passes_opt, lineups[1]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup2.passing_passes_accuracy_opt, lineups[1]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup2.passing_key_passes_opt, lineups[1]->passing_key_passes_opt);
		EXPECT_EQ(lineup2.dribbles_attempts_opt, lineups[1]->dribbles_attempts_opt);
		EXPECT_EQ(lineup2.dribbles_success_opt, lineups[1]->dribbles_success_opt);
		EXPECT_EQ(lineup2.dribbles_dribbled_past_opt, lineups[1]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup2.duels_total_opt, lineups[1]->duels_total_opt);
		EXPECT_EQ(lineup2.duels_won_opt, lineups[1]->duels_won_opt);
		EXPECT_EQ(lineup2.aerials_won_opt, lineups[1]->aerials_won_opt);
		EXPECT_EQ(lineup2.punches_opt, lineups[1]->punches_opt);
		EXPECT_EQ(lineup2.offsides_opt, lineups[1]->offsides_opt);
		EXPECT_EQ(lineup2.saves_opt, lineups[1]->saves_opt);
		EXPECT_EQ(lineup2.inside_box_saves_opt, lineups[1]->inside_box_saves_opt);
		EXPECT_EQ(lineup2.penalty_scored_opt, lineups[1]->penalty_scored_opt);
		EXPECT_EQ(lineup2.penalty_missed_opt, lineups[1]->penalty_missed_opt);
		EXPECT_EQ(lineup2.penalty_saved_opt, lineups[1]->penalty_saved_opt);
		EXPECT_EQ(lineup2.penalty_committed_opt, lineups[1]->penalty_committed_opt);
		EXPECT_EQ(lineup2.penalty_won_opt, lineups[1]->penalty_won_opt);
		EXPECT_EQ(lineup2.hit_woodwork_opt, lineups[1]->hit_woodwork_opt);
		EXPECT_EQ(lineup2.tackles_opt, lineups[1]->tackles_opt);
		EXPECT_EQ(lineup2.blocks_opt, lineups[1]->blocks_opt);
		EXPECT_EQ(lineup2.interceptions_opt, lineups[1]->interceptions_opt);
		EXPECT_EQ(lineup2.clearances_opt, lineups[1]->clearances_opt);
		EXPECT_EQ(lineup2.dispossesed_opt, lineups[1]->dispossesed_opt);
		EXPECT_EQ(lineup2.minutes_played_opt, lineups[1]->minutes_played_opt);
		EXPECT_EQ(lineup2.rating_opt, lineups[1]->rating_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, threelineups));
	ASSERT_EQ(3, QueryCount<Lineup>(db));
	{
		auto lineups = QueryAll<Lineup>(db);
		EXPECT_EQ(3, lineups.size());

		EXPECT_NE(0, lineups[0]->id);
		EXPECT_EQ(lineup1.sm_team_id, lineups[0]->sm_team_id);
		EXPECT_EQ(lineup1.sm_fixture_id, lineups[0]->sm_fixture_id);
		EXPECT_EQ(lineup1.sm_player_id, lineups[0]->sm_player_id);
		EXPECT_EQ(lineup1.player_name, lineups[0]->player_name);
		EXPECT_EQ(lineup1.number, lineups[0]->number);
		EXPECT_EQ(lineup1.position, lineups[0]->position);
		EXPECT_EQ(lineup1.additional_position_opt, lineups[0]->additional_position_opt);
		EXPECT_EQ(lineup1.formation_position_opt, lineups[0]->formation_position_opt);
		EXPECT_EQ(lineup1.posx_opt, lineups[0]->posx_opt);
		EXPECT_EQ(lineup1.posy_opt, lineups[0]->posy_opt);
		EXPECT_EQ(lineup1.captain_opt, lineups[0]->captain_opt);
		EXPECT_EQ(lineup1.type, lineups[0]->type);
		EXPECT_EQ(lineup1.shots_total_opt, lineups[0]->shots_total_opt);
		EXPECT_EQ(lineup1.shots_on_goal_opt, lineups[0]->shots_on_goal_opt);
		EXPECT_EQ(lineup1.goals_scored_opt, lineups[0]->goals_scored_opt);
		EXPECT_EQ(lineup1.goals_assists_opt, lineups[0]->goals_assists_opt);
		EXPECT_EQ(lineup1.goals_conceded_opt, lineups[0]->goals_conceded_opt);
		EXPECT_EQ(lineup1.goals_owngoals_opt, lineups[0]->goals_owngoals_opt);
		EXPECT_EQ(lineup1.fouls_drawn_opt, lineups[0]->fouls_drawn_opt);
		EXPECT_EQ(lineup1.fouls_committed_opt, lineups[0]->fouls_committed_opt);
		EXPECT_EQ(lineup1.yellowcards_opt, lineups[0]->yellowcards_opt);
		EXPECT_EQ(lineup1.redcards_opt, lineups[0]->redcards_opt);
		EXPECT_EQ(lineup1.yellowredcards_opt, lineups[0]->yellowredcards_opt);
		EXPECT_EQ(lineup1.passing_total_crosses_opt, lineups[0]->passing_total_crosses_opt);
		EXPECT_EQ(lineup1.passing_crosses_accuracy_opt, lineups[0]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup1.passing_passes_opt, lineups[0]->passing_passes_opt);
		EXPECT_EQ(lineup1.passing_accurate_passes_opt, lineups[0]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup1.passing_passes_accuracy_opt, lineups[0]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup1.passing_key_passes_opt, lineups[0]->passing_key_passes_opt);
		EXPECT_EQ(lineup1.dribbles_attempts_opt, lineups[0]->dribbles_attempts_opt);
		EXPECT_EQ(lineup1.dribbles_success_opt, lineups[0]->dribbles_success_opt);
		EXPECT_EQ(lineup1.dribbles_dribbled_past_opt, lineups[0]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup1.duels_total_opt, lineups[0]->duels_total_opt);
		EXPECT_EQ(lineup1.duels_won_opt, lineups[0]->duels_won_opt);
		EXPECT_EQ(lineup1.aerials_won_opt, lineups[0]->aerials_won_opt);
		EXPECT_EQ(lineup1.punches_opt, lineups[0]->punches_opt);
		EXPECT_EQ(lineup1.offsides_opt, lineups[0]->offsides_opt);
		EXPECT_EQ(lineup1.saves_opt, lineups[0]->saves_opt);
		EXPECT_EQ(lineup1.inside_box_saves_opt, lineups[0]->inside_box_saves_opt);
		EXPECT_EQ(lineup1.penalty_scored_opt, lineups[0]->penalty_scored_opt);
		EXPECT_EQ(lineup1.penalty_missed_opt, lineups[0]->penalty_missed_opt);
		EXPECT_EQ(lineup1.penalty_saved_opt, lineups[0]->penalty_saved_opt);
		EXPECT_EQ(lineup1.penalty_committed_opt, lineups[0]->penalty_committed_opt);
		EXPECT_EQ(lineup1.penalty_won_opt, lineups[0]->penalty_won_opt);
		EXPECT_EQ(lineup1.hit_woodwork_opt, lineups[0]->hit_woodwork_opt);
		EXPECT_EQ(lineup1.tackles_opt, lineups[0]->tackles_opt);
		EXPECT_EQ(lineup1.blocks_opt, lineups[0]->blocks_opt);
		EXPECT_EQ(lineup1.interceptions_opt, lineups[0]->interceptions_opt);
		EXPECT_EQ(lineup1.clearances_opt, lineups[0]->clearances_opt);
		EXPECT_EQ(lineup1.dispossesed_opt, lineups[0]->dispossesed_opt);
		EXPECT_EQ(lineup1.minutes_played_opt, lineups[0]->minutes_played_opt);
		EXPECT_EQ(lineup1.rating_opt, lineups[0]->rating_opt);
		

		EXPECT_NE(0, lineups[1]->id);
		EXPECT_EQ(lineup2.sm_team_id, lineups[1]->sm_team_id);
		EXPECT_EQ(lineup2.sm_fixture_id, lineups[1]->sm_fixture_id);
		EXPECT_EQ(lineup2.sm_player_id, lineups[1]->sm_player_id);
		EXPECT_EQ(lineup2.player_name, lineups[1]->player_name);
		EXPECT_EQ(lineup2.number, lineups[1]->number);
		EXPECT_EQ(lineup2.position, lineups[1]->position);
		EXPECT_EQ(lineup2.additional_position_opt, lineups[1]->additional_position_opt);
		EXPECT_EQ(lineup2.formation_position_opt, lineups[1]->formation_position_opt);
		EXPECT_EQ(lineup2.posx_opt, lineups[1]->posx_opt);
		EXPECT_EQ(lineup2.posy_opt, lineups[1]->posy_opt);
		EXPECT_EQ(lineup2.captain_opt, lineups[1]->captain_opt);
		EXPECT_EQ(lineup2.type, lineups[1]->type);
		EXPECT_EQ(lineup2.shots_total_opt, lineups[1]->shots_total_opt);
		EXPECT_EQ(lineup2.shots_on_goal_opt, lineups[1]->shots_on_goal_opt);
		EXPECT_EQ(lineup2.goals_scored_opt, lineups[1]->goals_scored_opt);
		EXPECT_EQ(lineup2.goals_assists_opt, lineups[1]->goals_assists_opt);
		EXPECT_EQ(lineup2.goals_conceded_opt, lineups[1]->goals_conceded_opt);
		EXPECT_EQ(lineup2.goals_owngoals_opt, lineups[1]->goals_owngoals_opt);
		EXPECT_EQ(lineup2.fouls_drawn_opt, lineups[1]->fouls_drawn_opt);
		EXPECT_EQ(lineup2.fouls_committed_opt, lineups[1]->fouls_committed_opt);
		EXPECT_EQ(lineup2.yellowcards_opt, lineups[1]->yellowcards_opt);
		EXPECT_EQ(lineup2.redcards_opt, lineups[1]->redcards_opt);
		EXPECT_EQ(lineup2.yellowredcards_opt, lineups[1]->yellowredcards_opt);
		EXPECT_EQ(lineup2.passing_total_crosses_opt, lineups[1]->passing_total_crosses_opt);
		EXPECT_EQ(lineup2.passing_crosses_accuracy_opt, lineups[1]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup2.passing_passes_opt, lineups[1]->passing_passes_opt);
		EXPECT_EQ(lineup2.passing_accurate_passes_opt, lineups[1]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup2.passing_passes_accuracy_opt, lineups[1]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup2.passing_key_passes_opt, lineups[1]->passing_key_passes_opt);
		EXPECT_EQ(lineup2.dribbles_attempts_opt, lineups[1]->dribbles_attempts_opt);
		EXPECT_EQ(lineup2.dribbles_success_opt, lineups[1]->dribbles_success_opt);
		EXPECT_EQ(lineup2.dribbles_dribbled_past_opt, lineups[1]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup2.duels_total_opt, lineups[1]->duels_total_opt);
		EXPECT_EQ(lineup2.duels_won_opt, lineups[1]->duels_won_opt);
		EXPECT_EQ(lineup2.aerials_won_opt, lineups[1]->aerials_won_opt);
		EXPECT_EQ(lineup2.punches_opt, lineups[1]->punches_opt);
		EXPECT_EQ(lineup2.offsides_opt, lineups[1]->offsides_opt);
		EXPECT_EQ(lineup2.saves_opt, lineups[1]->saves_opt);
		EXPECT_EQ(lineup2.inside_box_saves_opt, lineups[1]->inside_box_saves_opt);
		EXPECT_EQ(lineup2.penalty_scored_opt, lineups[1]->penalty_scored_opt);
		EXPECT_EQ(lineup2.penalty_missed_opt, lineups[1]->penalty_missed_opt);
		EXPECT_EQ(lineup2.penalty_saved_opt, lineups[1]->penalty_saved_opt);
		EXPECT_EQ(lineup2.penalty_committed_opt, lineups[1]->penalty_committed_opt);
		EXPECT_EQ(lineup2.penalty_won_opt, lineups[1]->penalty_won_opt);
		EXPECT_EQ(lineup2.hit_woodwork_opt, lineups[1]->hit_woodwork_opt);
		EXPECT_EQ(lineup2.tackles_opt, lineups[1]->tackles_opt);
		EXPECT_EQ(lineup2.blocks_opt, lineups[1]->blocks_opt);
		EXPECT_EQ(lineup2.interceptions_opt, lineups[1]->interceptions_opt);
		EXPECT_EQ(lineup2.clearances_opt, lineups[1]->clearances_opt);
		EXPECT_EQ(lineup2.dispossesed_opt, lineups[1]->dispossesed_opt);
		EXPECT_EQ(lineup2.minutes_played_opt, lineups[1]->minutes_played_opt);
		EXPECT_EQ(lineup2.rating_opt, lineups[1]->rating_opt);
		

		EXPECT_NE(0, lineups[2]->id);
		EXPECT_EQ(lineup3.sm_team_id, lineups[2]->sm_team_id);
		EXPECT_EQ(lineup3.sm_fixture_id, lineups[2]->sm_fixture_id);
		EXPECT_EQ(lineup3.sm_player_id, lineups[2]->sm_player_id);
		EXPECT_EQ(lineup3.player_name, lineups[2]->player_name);
		EXPECT_EQ(lineup3.number, lineups[2]->number);
		EXPECT_EQ(lineup3.position, lineups[2]->position);
		EXPECT_EQ(lineup3.additional_position_opt, lineups[2]->additional_position_opt);
		EXPECT_EQ(lineup3.formation_position_opt, lineups[2]->formation_position_opt);
		EXPECT_EQ(lineup3.posx_opt, lineups[2]->posx_opt);
		EXPECT_EQ(lineup3.posy_opt, lineups[2]->posy_opt);
		EXPECT_EQ(lineup3.captain_opt, lineups[2]->captain_opt);
		EXPECT_EQ(lineup3.type, lineups[2]->type);
		EXPECT_EQ(lineup3.shots_total_opt, lineups[2]->shots_total_opt);
		EXPECT_EQ(lineup3.shots_on_goal_opt, lineups[2]->shots_on_goal_opt);
		EXPECT_EQ(lineup3.goals_scored_opt, lineups[2]->goals_scored_opt);
		EXPECT_EQ(lineup3.goals_assists_opt, lineups[2]->goals_assists_opt);
		EXPECT_EQ(lineup3.goals_conceded_opt, lineups[2]->goals_conceded_opt);
		EXPECT_EQ(lineup3.goals_owngoals_opt, lineups[2]->goals_owngoals_opt);
		EXPECT_EQ(lineup3.fouls_drawn_opt, lineups[2]->fouls_drawn_opt);
		EXPECT_EQ(lineup3.fouls_committed_opt, lineups[2]->fouls_committed_opt);
		EXPECT_EQ(lineup3.yellowcards_opt, lineups[2]->yellowcards_opt);
		EXPECT_EQ(lineup3.redcards_opt, lineups[2]->redcards_opt);
		EXPECT_EQ(lineup3.yellowredcards_opt, lineups[2]->yellowredcards_opt);
		EXPECT_EQ(lineup3.passing_total_crosses_opt, lineups[2]->passing_total_crosses_opt);
		EXPECT_EQ(lineup3.passing_crosses_accuracy_opt, lineups[2]->passing_crosses_accuracy_opt);
		EXPECT_EQ(lineup3.passing_passes_opt, lineups[2]->passing_passes_opt);
		EXPECT_EQ(lineup3.passing_accurate_passes_opt, lineups[2]->passing_accurate_passes_opt);
		EXPECT_EQ(lineup3.passing_passes_accuracy_opt, lineups[2]->passing_passes_accuracy_opt);
		EXPECT_EQ(lineup3.passing_key_passes_opt, lineups[2]->passing_key_passes_opt);
		EXPECT_EQ(lineup3.dribbles_attempts_opt, lineups[2]->dribbles_attempts_opt);
		EXPECT_EQ(lineup3.dribbles_success_opt, lineups[2]->dribbles_success_opt);
		EXPECT_EQ(lineup3.dribbles_dribbled_past_opt, lineups[2]->dribbles_dribbled_past_opt);
		EXPECT_EQ(lineup3.duels_total_opt, lineups[2]->duels_total_opt);
		EXPECT_EQ(lineup3.duels_won_opt, lineups[2]->duels_won_opt);
		EXPECT_EQ(lineup3.aerials_won_opt, lineups[2]->aerials_won_opt);
		EXPECT_EQ(lineup3.punches_opt, lineups[2]->punches_opt);
		EXPECT_EQ(lineup3.offsides_opt, lineups[2]->offsides_opt);
		EXPECT_EQ(lineup3.saves_opt, lineups[2]->saves_opt);
		EXPECT_EQ(lineup3.inside_box_saves_opt, lineups[2]->inside_box_saves_opt);
		EXPECT_EQ(lineup3.penalty_scored_opt, lineups[2]->penalty_scored_opt);
		EXPECT_EQ(lineup3.penalty_missed_opt, lineups[2]->penalty_missed_opt);
		EXPECT_EQ(lineup3.penalty_saved_opt, lineups[2]->penalty_saved_opt);
		EXPECT_EQ(lineup3.penalty_committed_opt, lineups[2]->penalty_committed_opt);
		EXPECT_EQ(lineup3.penalty_won_opt, lineups[2]->penalty_won_opt);
		EXPECT_EQ(lineup3.hit_woodwork_opt, lineups[2]->hit_woodwork_opt);
		EXPECT_EQ(lineup3.tackles_opt, lineups[2]->tackles_opt);
		EXPECT_EQ(lineup3.blocks_opt, lineups[2]->blocks_opt);
		EXPECT_EQ(lineup3.interceptions_opt, lineups[2]->interceptions_opt);
		EXPECT_EQ(lineup3.clearances_opt, lineups[2]->clearances_opt);
		EXPECT_EQ(lineup3.dispossesed_opt, lineups[2]->dispossesed_opt);
		EXPECT_EQ(lineup3.minutes_played_opt, lineups[2]->minutes_played_opt);
		EXPECT_EQ(lineup3.rating_opt, lineups[2]->rating_opt);
		
	}
}